# -*- coding: utf-8 -*-
"""Scrip_relatorio_de_compras.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1bDED2J3_yqWrQWl0e7EvrgFwQBOJRmja
"""

# 📦 Instalação de dependências (se necessário) / Scrip: relatorio - resumo da emergencia;
!pip install openpyxl --quiet
# Importando bibliotecas:
import pandas as pd
import numpy as np

# 📁 1. Upload do arquivo de dados

try:
      from google.colab import files
      uploaded = files.upload()
      if not uploaded:
          raise ValueError("Nenhum arquivo foi carregado.") # Trantando erro do arquivo

      # Leitura do arquivo:
      Data_base = list(uploaded.keys())[0]
      Base_resumo_emergencia = pd.read_excel('Data_base.xlsx')
except IndexError as e:
  print('Erro - Index.Erro',e)
except Exception as e:
  print('Erro - Exception.Erro',e)


try: # Processando relatorio e suas dependencias

      # Valor total do itempor pedido;
      Base_resumo_emergencia['Valor_Total'] = Base_resumo_emergencia['PedidoCompraItem_Qtde'] * Base_resumo_emergencia['PedidoCompraItem_ValorTotal']

      # Definindo fornecedor:
      Fornecedor_resumo_emergencia = (Base_resumo_emergencia['Pessoa_Nome'] == 'TOYOTA DO BRASIL LTDA')

      # # #:
      Resumo_emergencia_Analitico = Base_resumo_emergencia.groupby(['PedidoCompra_EmpresaCod','PedidoCompra_Codigo']).agg({
          'PedidoCompra_NroMontadora':'first',
          'Pessoa_Nome':'first',
          'PedidoCompra_DataCriacao':'first',
          'ProdutoMarca_Referencia':'first',
          'Produto_Descricao':'first',
          'PedidoCompraItem_Qtde': 'sum',
          'PedidoCompraItem_ValorTotal':'mean',
          'Valor_Total':'sum',
          'TipoPedido_Descricao':'first',
          'ProdutoEstoque_ClasABCLetraPopularidade':'first'

      })

      # # # Tabela de itens D, E e inativos;

      df = Base_resumo_emergencia

      categoria_class = ['D1','D2','E0','E1','F','G','H','I','J']

      if 'ProdutoEstoque_ClasABCLetraPopularidade' in df.columns:
          # friltrando os itens D,E e Inativos
          df_itens_D_E_Inativos = df[df['ProdutoEstoque_ClasABCLetraPopularidade'].isin(categoria_class)]
          Resumo_emergencia_D_E_Inativos = df_itens_D_E_Inativos.groupby(['PedidoCompra_EmpresaCod','ProdutoEstoque_ClasABCLetraPopularidade','ProdutoMarca_Referencia','PedidoCompraItem_ValorTotal'])['PedidoCompraItem_Qtde'].sum().reset_index() # .reset_index() transforma as chaves do groupby em colunas novamente
      else:
          print("Erro: A coluna 'ProdutoEstoque_ClasABCLetraPopularidade' não foi encontrada. O resumo de emergência não pôde ser gerado.")

      # # # Tabela de itens A,B e C;

      df = Base_resumo_emergencia

      categoria_class = ['A1','A2','A3','B1','B2','B3','C1','C2','C3']

      if 'ProdutoEstoque_ClasABCLetraPopularidade' in df.columns:
          # friltrando os itens A,B e C
          df_itens_A_B_C = df[df['ProdutoEstoque_ClasABCLetraPopularidade'].isin(categoria_class)]
          Resumo_emergencia_A_B_C = df_itens_A_B_C.groupby(['PedidoCompra_EmpresaCod','ProdutoEstoque_ClasABCLetraPopularidade','ProdutoMarca_Referencia','PedidoCompraItem_ValorTotal'])['PedidoCompraItem_Qtde'].sum().reset_index() # A utilização de df['coluna'].isin(lista) é a forma correta e eficiente de filtrar por múltiplos valores.
      else:
          print("Erro: A coluna 'ProdutoEstoque_ClasABCLetraPopularidade' não foi encontrada. O resumo de emergência não pôde ser gerado.")

      # Criando o relatorio final:
      try:
          from google.colab import drive
          drive.mount('/content/drive')
          caminho_arquivo = '/content/drive/MyDrive/Acompanhamento/Resumo_emergencia.xlsx'
          with pd.ExcelWriter(caminho_arquivo, engine='openpyxl') as writer:
              Resumo_emergencia_Analitico.to_excel(writer, sheet_name='Resumo_emergencia_Analitico')
              Resumo_emergencia_A_B_C.to_excel(writer, sheet_name='Resumo_emergencia_A_B_C')
              Resumo_emergencia_D_E_Inativos.to_excel(writer, sheet_name='Resumo_emergencia_D_E_Inativos')

              print(f"RELATORIO SALVO COM SUCESSO: {caminho_arquivo}")
      except Exception as e:
        print('Erro - Exception.Erro',e)

except IndexError as e:
  print('Erro - Index.Erro',e)
except KeyError as e:
  print('Erro - Key.Erro',e)
except TypeError as e:
  print('Erro - Type.Erro',e)
except Exception as e:
  print('Erro - Exception.Erro',e)